Program Edit (Input,Output,PlayerDat);
Uses Crt;

Type
  CharArray = Array [0..311] of Byte;
  ItemArray = Array [0..7] of Byte;
  InventArray = Array [1..500] of ItemArray;
  InventRecord = Record
                  Items: InventArray;
                  NumItems: Integer;
                End;
  PlayerFile = File of Byte;
  AbilNameArray = Array [0..22] of String;
  AnItem = String[20];
  Stuff = Record
            Abilities: AbilNameArray;
            VitCur, VitMax, CurMana, MaxMana, Food, Level, Encum,
              XP, UDPos, EWPos, NSPos, Head, DLevel, Name: String;
            ItemStuff: Array[0..511] of AnItem;
            Spells: Array[0..63] of AnItem;
          End;

Var
  PlayerDat: PlayerFile;
  Character: CharArray;
  Inventory: InventRecord;
  SStuff: Stuff;
  Duh: Byte;

Procedure Setup (Var SStuff: Stuff{Out});
Begin
  SStuff.Abilities[00] := 'Strength......';
  SStuff.Abilities[01] := 'Dexterity.....';
  SStuff.Abilities[02] := 'Intelligence..';
  SStuff.Abilities[03] := 'Attack........';
  SStuff.Abilities[04] := 'Defense.......';
  SStuff.Abilities[05] := 'Unarmed.......';
  SStuff.Abilities[06] := 'Sword.........';
  SStuff.Abilities[07] := 'Axe...........';
  SStuff.Abilities[08] := 'Mace..........';
  SStuff.Abilities[09] := 'Missile.......';
  SStuff.Abilities[10] := 'Mana..........';
  SStuff.Abilities[11] := 'Lore..........';
  SStuff.Abilities[12] := 'Casting.......';
  SStuff.Abilities[13] := 'Traps.........';
  SStuff.Abilities[14] := 'Search........';
  SStuff.Abilities[15] := 'Track.........';
  SStuff.Abilities[16] := 'Sneak.........';
  SStuff.Abilities[17] := 'Repair........';
  SStuff.Abilities[18] := 'Charm.........';
  SStuff.Abilities[19] := 'Picklock......';
  SStuff.Abilities[20] := 'Acrobat.......';
  SStuff.Abilities[21] := 'Appraise......';
  SStuff.Abilities[22] := 'Swimming......';
  SStuff.VitCur        := 'Current Vitality..';
  SStuff.VitMax        := 'Maximum Vitality..';
  SStuff.CurMana       := 'Current Mana......';
  SStuff.MaxMana       := 'Maximum Mana......';
  SStuff.Food          := 'Fullness (food)...';
  SStuff.Level         := 'Experience Level..';
  SStuff.Encum         := 'Encumberance......';
  SStuff.EWPos         := 'E/W Position......';
  SStuff.NSPos         := 'N/S Position......';
  SStuff.UDPos         := 'U/D Position......';
  SStuff.Head          := 'Heading...........';
  SStuff.DLevel        := 'Dungeon Level.....';
  SStuff.XP            := 'Experience........';
  SStuff.Name          := 'Character''s Name..';
  SStuff.ItemStuff[000] := 'Hand Axe';
  SStuff.ItemStuff[001] := 'Battle Axe';
  SStuff.ItemStuff[002] := 'Axe';
  SStuff.ItemStuff[003] := 'Daggar';
  SStuff.ItemStuff[004] := 'Shortsword';
  SStuff.ItemStuff[005] := 'Longsword';
  SStuff.ItemStuff[006] := 'Broadsword';
  SStuff.ItemStuff[007] := 'Cudgel';
  SStuff.ItemStuff[008] := 'Light Mace';
  SStuff.ItemStuff[009] := 'Mace';
  SStuff.ItemStuff[010] := 'Sword of Justice';
  SStuff.ItemStuff[011] := 'Jeweled Axe';
  SStuff.ItemStuff[012] := 'Black Sword';
  SStuff.ItemStuff[013] := 'Jeweled Sword';
  SStuff.ItemStuff[014] := 'Jeweled Mace';
  SStuff.ItemStuff[015] := 'Fist';
  SStuff.ItemStuff[016] := 'Sling Stone';
  SStuff.ItemStuff[017] := 'Crossbow Bolt';
  SStuff.ItemStuff[018] := 'Arrow';
  SStuff.ItemStuff[019] := 'Stone';
  SStuff.ItemStuff[020] := 'Fireball';
  SStuff.ItemStuff[021] := 'Lightning Bolt';
  SStuff.ItemStuff[022] := 'Acid';
  SStuff.ItemStuff[023] := 'Magic Missile';
  SStuff.ItemStuff[024] := 'Sling';
  SStuff.ItemStuff[025] := 'Bow';
  SStuff.ItemStuff[026] := 'Crossbow';
  SStuff.ItemStuff[027] := '?';
  SStuff.ItemStuff[028] := '?';
  SStuff.ItemStuff[029] := '?';
  SStuff.ItemStuff[030] := '?';
  SStuff.ItemStuff[031] := 'Jeweled Bow';
  SStuff.ItemStuff[032] := 'Leather Vest';
  SStuff.ItemStuff[033] := 'Mail Shirt';
  SStuff.ItemStuff[034] := 'Breast Plate';
  SStuff.ItemStuff[035] := 'Leather Leggings';
  SStuff.ItemStuff[036] := 'Mail Leggings';
  SStuff.ItemStuff[037] := 'Plate Leggings';
  SStuff.ItemStuff[038] := 'Leather Gloves';
  SStuff.ItemStuff[039] := 'Chain Gauntlets';
  SStuff.ItemStuff[040] := 'Plate Gauntlets';
  SStuff.ItemStuff[041] := 'Leather Boots';
  SStuff.ItemStuff[042] := 'Chain Boots';
  SStuff.ItemStuff[043] := 'Plate Boots';
  SStuff.ItemStuff[044] := 'Leather Cap';
  SStuff.ItemStuff[045] := 'Chain Cowl';
  SStuff.ItemStuff[046] := 'Helmet';
  SStuff.ItemStuff[047] := 'Dragonskin Boots';
  SStuff.ItemStuff[048] := 'Crown #1';
  SStuff.ItemStuff[049] := 'Crown #2';
  SStuff.ItemStuff[050] := 'Crown #3';
  SStuff.ItemStuff[051] := '?';
  SStuff.ItemStuff[052] := '?';
  SStuff.ItemStuff[053] := '?';
  SStuff.ItemStuff[054] := 'Ring of Humility';
  SStuff.ItemStuff[055] := 'Shield of Valor';
  SStuff.ItemStuff[056] := 'Gold Ring';
  SStuff.ItemStuff[057] := 'Silver Ring';
  SStuff.ItemStuff[058] := 'Red Ring';
  SStuff.ItemStuff[059] := 'Tower Shield';
  SStuff.ItemStuff[060] := 'Wooden Shield';
  SStuff.ItemStuff[061] := 'Small Shield';
  SStuff.ItemStuff[062] := 'Buckler';
  SStuff.ItemStuff[063] := 'Jeweled Shield';
  SStuff.ItemStuff[064] := 'Rot Worm';
  SStuff.ItemStuff[065] := 'Flesh Slug';
  SStuff.ItemStuff[066] := 'Cave Bat';
  SStuff.ItemStuff[067] := 'Giant Rat';
  SStuff.ItemStuff[068] := 'Giant Spider';
  SStuff.ItemStuff[069] := 'Acid Slug';
  SStuff.ItemStuff[070] := 'Green Goblin 1';
  SStuff.ItemStuff[071] := 'Green Goblin 2';
  SStuff.ItemStuff[072] := 'Giant Rat';
  SStuff.ItemStuff[073] := 'Vampire Bat';
  SStuff.ItemStuff[074] := 'Skeleton';
  SStuff.ItemStuff[075] := 'Imp';
  SStuff.ItemStuff[076] := 'Gray Goblin 1';
  SStuff.ItemStuff[077] := 'Green Goblin 3';
  SStuff.ItemStuff[078] := 'Gray Goblin 2';
  SStuff.ItemStuff[079] := 'Level 9 Thing';
  SStuff.ItemStuff[080] := 'Gray Goblin 3';
  SStuff.ItemStuff[081] := 'Mongbat';
  SStuff.ItemStuff[082] := 'Bloodworm';
  SStuff.ItemStuff[083] := 'Wolf Spider';
  SStuff.ItemStuff[084] := 'Mountainman 1';
  SStuff.ItemStuff[085] := 'Green Lizardman';
  SStuff.ItemStuff[086] := 'Mountainman 2';
  SStuff.ItemStuff[087] := 'Lurker';
  SStuff.ItemStuff[088] := 'Red Lizardman';
  SStuff.ItemStuff[089] := 'Gray Lizardman';
  SStuff.ItemStuff[090] := 'Outcast';
  SStuff.ItemStuff[091] := 'Headless';
  SStuff.ItemStuff[092] := 'Dread Spider';
  SStuff.ItemStuff[093] := 'Fighter 1';
  SStuff.ItemStuff[094] := 'Fighter 2';
  SStuff.ItemStuff[095] := 'Fighter 3';
  SStuff.ItemStuff[096] := 'Troll';
  SStuff.ItemStuff[097] := 'White Ghost 1';
  SStuff.ItemStuff[098] := 'Fighter 4';
  SStuff.ItemStuff[099] := 'Ghoul 1';
  SStuff.ItemStuff[100] := 'White Ghost 2';
  SStuff.ItemStuff[101] := 'Blue Ghost';
  SStuff.ItemStuff[102] := 'Gazer';
  SStuff.ItemStuff[103] := 'Seer 1';
  SStuff.ItemStuff[104] := 'Fighter 5';
  SStuff.ItemStuff[105] := 'Dark Ghoul';
  SStuff.ItemStuff[106] := 'Seer 2';
  SStuff.ItemStuff[107] := 'Seer 3';
  SStuff.ItemStuff[108] := 'Seer 4';
  SStuff.ItemStuff[109] := 'Seer 5';
  SStuff.ItemStuff[110] := 'Ghoul 2';
  SStuff.ItemStuff[111] := 'Feral Troll';
  SStuff.ItemStuff[112] := 'Great Troll';
  SStuff.ItemStuff[113] := 'Dire Ghost';
  SStuff.ItemStuff[114] := 'Earth Golem';
  SStuff.ItemStuff[115] := 'Seer 6';
  SStuff.ItemStuff[116] := 'Deep Lurker';
  SStuff.ItemStuff[117] := 'Shadow Beast';
  SStuff.ItemStuff[118] := 'Reaper';
  SStuff.ItemStuff[119] := 'Stone Golem';
  SStuff.ItemStuff[120] := 'Fire Elemental';
  SStuff.ItemStuff[121] := 'Metal Golem';
  SStuff.ItemStuff[122] := 'Wisp';
  SStuff.ItemStuff[123] := 'Tyball';
  SStuff.ItemStuff[124] := 'Slasher of Veils';
  SStuff.ItemStuff[125] := 'Lightning Bolt';
  SStuff.ItemStuff[126] := 'Don''t Use.';
  SStuff.ItemStuff[127] := 'Adventurer';
  SStuff.ItemStuff[128] := 'Sack';
  SStuff.ItemStuff[129] := 'Open Sack';
  SStuff.ItemStuff[130] := 'Backpack';
  SStuff.ItemStuff[131] := 'Open Backpack';
  SStuff.ItemStuff[132] := 'Box';
  SStuff.ItemStuff[133] := 'Open Box';
  SStuff.ItemStuff[134] := 'Pouch';
  SStuff.ItemStuff[135] := 'Open Pouch';
  SStuff.ItemStuff[136] := 'Scroll Case';
  SStuff.ItemStuff[137] := 'Open Scroll Case';
  SStuff.ItemStuff[138] := 'Metal Box';
  SStuff.ItemStuff[139] := 'Open Metal Box';
  SStuff.ItemStuff[140] := 'Urn';
  SStuff.ItemStuff[141] := 'Quiver';
  SStuff.ItemStuff[142] := 'Bowl';
  SStuff.ItemStuff[143] := 'Runebag';
  SStuff.ItemStuff[144] := 'Lantern';
  SStuff.ItemStuff[145] := 'Torch';
  SStuff.ItemStuff[146] := 'Candle';
  SStuff.ItemStuff[147] := 'Taper of Sacrifice';
  SStuff.ItemStuff[148] := 'Lit Lantern';
  SStuff.ItemStuff[149] := 'Lit Torch';
  SStuff.ItemStuff[150] := 'Lit Candle';
  SStuff.ItemStuff[151] := 'Lit Taper';
  SStuff.ItemStuff[152] := 'Wand 1';
  SStuff.ItemStuff[153] := 'Wand 2';
  SStuff.ItemStuff[154] := 'Wand 3';
  SStuff.ItemStuff[155] := 'Wand 4';
  SStuff.ItemStuff[156] := 'Broken Wand 1';
  SStuff.ItemStuff[157] := 'Broken Wand 2';
  SStuff.ItemStuff[158] := 'Broken Wand 3';
  SStuff.ItemStuff[159] := 'Broken Wand 4';
  SStuff.ItemStuff[160] := 'Coins';
  SStuff.ItemStuff[161] := 'Coin';
  SStuff.ItemStuff[162] := 'Ruby';
  SStuff.ItemStuff[163] := 'Red Gem';
  SStuff.ItemStuff[164] := 'Small Blue Gem';
  SStuff.ItemStuff[165] := 'Large Blue Gem';
  SStuff.ItemStuff[166] := 'Sapphire';
  SStuff.ItemStuff[167] := 'Emerald';
  SStuff.ItemStuff[168] := 'Amulet';
  SStuff.ItemStuff[169] := 'Goblet';
  SStuff.ItemStuff[170] := 'Sceptre';
  SStuff.ItemStuff[171] := 'Gold Chain';
  SStuff.ItemStuff[172] := 'Gold Plate';
  SStuff.ItemStuff[173] := 'Ankh';
  SStuff.ItemStuff[174] := 'Cup of Wonder';
  SStuff.ItemStuff[175] := 'Gold Nugget';
  SStuff.ItemStuff[176] := 'Meat';
  SStuff.ItemStuff[177] := 'Bread 1';
  SStuff.ItemStuff[178] := 'Cheese';
  SStuff.ItemStuff[179] := 'Apple';
  SStuff.ItemStuff[180] := 'Ear of Corn';
  SStuff.ItemStuff[181] := 'Bread 2';
  SStuff.ItemStuff[182] := 'Fish';
  SStuff.ItemStuff[183] := 'Popcorn';
  SStuff.ItemStuff[184] := 'Mushroom';
  SStuff.ItemStuff[185] := 'Toadstool';
  SStuff.ItemStuff[186] := 'Ale';
  SStuff.ItemStuff[187] := 'Red Potion';
  SStuff.ItemStuff[188] := 'Green Potion';
  SStuff.ItemStuff[189] := 'Water';
  SStuff.ItemStuff[190] := 'Port';
  SStuff.ItemStuff[191] := 'Wine of Compassion';
  SStuff.ItemStuff[192] := 'Plant 1';
  SStuff.ItemStuff[193] := 'Grass';
  SStuff.ItemStuff[194] := 'Skull 1';
  SStuff.ItemStuff[195] := 'Skull 2';
  SStuff.ItemStuff[196] := 'Bone 1';
  SStuff.ItemStuff[197] := 'Bone 2';
  SStuff.ItemStuff[198] := 'Bones';
  SStuff.ItemStuff[199] := 'Vines';
  SStuff.ItemStuff[200] := 'Broken Axe';
  SStuff.ItemStuff[201] := 'Broken Sword';
  SStuff.ItemStuff[202] := 'Broken Mace';
  SStuff.ItemStuff[203] := 'Broken Shield';
  SStuff.ItemStuff[204] := 'Wood 1';
  SStuff.ItemStuff[205] := 'Wood 2';
  SStuff.ItemStuff[206] := 'Plant 2';
  SStuff.ItemStuff[207] := 'Plant 3';
  SStuff.ItemStuff[208] := 'Debris 1';
  SStuff.ItemStuff[219] := 'Debris 2';
  SStuff.ItemStuff[210] := 'Debris 3';
  SStuff.ItemStuff[211] := 'Stalactite';
  SStuff.ItemStuff[212] := 'Plant 4';
  SStuff.ItemStuff[213] := 'Debris 4';
  SStuff.ItemStuff[214] := 'Debris 5';
  SStuff.ItemStuff[215] := 'Anvil';
  SStuff.ItemStuff[216] := 'Pole';
  SStuff.ItemStuff[217] := 'Dead Rotworm';
  SStuff.ItemStuff[218] := 'Rubble';
  SStuff.ItemStuff[219] := 'Wood Chips';
  SStuff.ItemStuff[220] := 'Skeleton Bones';
  SStuff.ItemStuff[221] := 'Green Blood';
  SStuff.ItemStuff[222] := 'Red Blood 1';
  SStuff.ItemStuff[223] := 'Red Blood 2';
  SStuff.ItemStuff[224] := 'Runestone';
  SStuff.ItemStuff[225] := 'Key of Truth';
  SStuff.ItemStuff[226] := 'Key of Love';
  SStuff.ItemStuff[227] := 'Key of Courage';
  SStuff.ItemStuff[228] := 'Two Part key 1';
  SStuff.ItemStuff[229] := 'Two Part key 2';
  SStuff.ItemStuff[230] := 'Two Part key 3';
  SStuff.ItemStuff[231] := 'Key of Infinity';
  SStuff.ItemStuff[232] := 'An Rune';
  SStuff.ItemStuff[233] := 'Bet Rune';
  SStuff.ItemStuff[234] := 'Corp Rune';
  SStuff.ItemStuff[235] := 'Des Rune';
  SStuff.ItemStuff[236] := 'Ex Rune';
  SStuff.ItemStuff[237] := 'Flam Rune';
  SStuff.ItemStuff[238] := 'Grav Rune';
  SStuff.ItemStuff[239] := 'Hur Rune';
  SStuff.ItemStuff[240] := 'In Rune';
  SStuff.ItemStuff[241] := 'Jux Rune';
  SStuff.ItemStuff[242] := 'Kal Rune';
  SStuff.ItemStuff[243] := 'Lor Rune';
  SStuff.ItemStuff[244] := 'Mani Rune';
  SStuff.ItemStuff[245] := 'Nox Rune';
  SStuff.ItemStuff[246] := 'Ort Rune';
  SStuff.ItemStuff[247] := 'Por Rune';
  SStuff.ItemStuff[248] := 'Quas Rune';
  SStuff.ItemStuff[249] := 'Rel Rune';
  SStuff.ItemStuff[250] := 'Sanct Rune';
  SStuff.ItemStuff[251] := 'Tym Rune';
  SStuff.ItemStuff[252] := 'Uus Rune';
  SStuff.ItemStuff[253] := 'Vas Rune';
  SStuff.ItemStuff[254] := 'Wis Rune';
  SStuff.ItemStuff[255] := 'Ylem Rune';
  SStuff.ItemStuff[256] := 'Yellow Key 1';
  SStuff.ItemStuff[257] := 'Lockpick';
  SStuff.ItemStuff[258] := 'Gray Key 1';
  SStuff.ItemStuff[259] := 'Brown Key 1';
  SStuff.ItemStuff[260] := 'Key 5';
  SStuff.ItemStuff[261] := 'Key 6';
  SStuff.ItemStuff[262] := 'Key 7';
  SStuff.ItemStuff[263] := 'Key 8';
  SStuff.ItemStuff[264] := 'Key 9';
  SStuff.ItemStuff[265] := 'Key 10';
  SStuff.ItemStuff[266] := 'Gray Key 2';
  SStuff.ItemStuff[267] := 'Key 12';
  SStuff.ItemStuff[268] := 'Key 13';
  SStuff.ItemStuff[269] := 'Gray Key 3';
  SStuff.ItemStuff[270] := 'Skull Key';
  SStuff.ItemStuff[271] := 'A Lock';
  SStuff.ItemStuff[272] := 'Picture of Tom';
  SStuff.ItemStuff[273] := 'Crystal Splinter';
  SStuff.ItemStuff[274] := 'Orb Rock';
  SStuff.ItemStuff[275] := 'Gem Cutter';
  SStuff.ItemStuff[276] := 'Exploding Book';
  SStuff.ItemStuff[277] := 'Burning Incense';
  SStuff.ItemStuff[278] := 'Block of Incense';
  SStuff.ItemStuff[279] := 'Tyball''s Orb';
  SStuff.ItemStuff[280] := 'Broken Blade';
  SStuff.ItemStuff[281] := 'Broken Hilt';
  SStuff.ItemStuff[282] := 'Figurine';
  SStuff.ItemStuff[283] := 'Rotworm Stew';
  SStuff.ItemStuff[284] := 'Strong Thread';
  SStuff.ItemStuff[285] := 'Dragon Scales';
  SStuff.ItemStuff[286] := 'Resilient Sphere';
  SStuff.ItemStuff[287] := 'Standard of Honor';
  SStuff.ItemStuff[288] := 'A Spell';
  SStuff.ItemStuff[289] := 'Bedroll';
  SStuff.ItemStuff[290] := 'Silver Seed';
  SStuff.ItemStuff[291] := 'Mandolin';
  SStuff.ItemStuff[292] := 'Flute';
  SStuff.ItemStuff[293] := 'Leeches';
  SStuff.ItemStuff[294] := 'Moonstone';
  SStuff.ItemStuff[295] := 'Spike';
  SStuff.ItemStuff[296] := 'Rock Hammer';
  SStuff.ItemStuff[297] := 'Zanite';
  SStuff.ItemStuff[298] := 'Campfire';
  SStuff.ItemStuff[299] := 'Fishing Pole';
  SStuff.ItemStuff[300] := 'Medalion';
  SStuff.ItemStuff[301] := 'Oil Flask';
  SStuff.ItemStuff[302] := 'Fountain';
  SStuff.ItemStuff[303] := 'Cauldron';
  SStuff.ItemStuff[304] := 'Book 1';
  SStuff.ItemStuff[305] := 'Book 2';
  SStuff.ItemStuff[306] := 'Book 3';
  SStuff.ItemStuff[307] := 'Book 4';
  SStuff.ItemStuff[308] := 'Book 5';
  SStuff.ItemStuff[309] := 'Book 6';
  SStuff.ItemStuff[310] := 'Book of Honesty';
  SStuff.ItemStuff[311] := 'Book 7';
  SStuff.ItemStuff[312] := 'Scroll 1';
  SStuff.ItemStuff[313] := 'Scroll 2';
  SStuff.ItemStuff[314] := 'Scroll 3';
  SStuff.ItemStuff[315] := 'Map';
  SStuff.ItemStuff[316] := 'Scroll 4';
  SStuff.ItemStuff[317] := 'Scroll 5';
  SStuff.ItemStuff[318] := 'Scroll 6';
  SStuff.ItemStuff[319] := 'Scroll 7';
  SStuff.ItemStuff[320] := 'Wooden Door 1';
  SStuff.ItemStuff[321] := 'MossWood Door';
  SStuff.ItemStuff[322] := 'Metal Door';
  SStuff.ItemStuff[323] := 'Skull Door';
  SStuff.ItemStuff[324] := 'Wooden Door 2';
  SStuff.ItemStuff[325] := 'Massive Stone Door';
  SStuff.ItemStuff[326] := 'Portcullis';
  SStuff.ItemStuff[327] := 'Secret Door';
  SStuff.ItemStuff[328] := 'Open Wooden Door 1';
  SStuff.ItemStuff[329] := 'Open MossWood Door';
  SStuff.ItemStuff[330] := 'Open Metal Door';
  SStuff.ItemStuff[331] := 'Open Skull Door';
  SStuff.ItemStuff[332] := 'Open Wooden Door 2';
  SStuff.ItemStuff[333] := 'Open Stone Door';
  SStuff.ItemStuff[334] := 'Open Portcullis';
  SStuff.ItemStuff[335] := 'Open Secret Door';
  SStuff.ItemStuff[336] := 'Bench';
  SStuff.ItemStuff[337] := 'Arrow (Prop)';
  SStuff.ItemStuff[338] := 'Bolt (Prop)';
  SStuff.ItemStuff[339] := 'Large Boulder 1';
  SStuff.ItemStuff[340] := 'Large Boulder 2';
  SStuff.ItemStuff[341] := 'Boulder';
  SStuff.ItemStuff[342] := 'Small Boulder';
  SStuff.ItemStuff[343] := 'Shrine';
  SStuff.ItemStuff[344] := 'Table';
  SStuff.ItemStuff[345] := 'Beam';
  SStuff.ItemStuff[346] := 'Moongate';
  SStuff.ItemStuff[347] := 'Barrel';
  SStuff.ItemStuff[348] := 'Chair';
  SStuff.ItemStuff[349] := 'Chest';
  SStuff.ItemStuff[350] := 'Nightstand';
  SStuff.ItemStuff[351] := 'Lotus Turbo Esprit';
  SStuff.ItemStuff[352] := 'Pillar';
  SStuff.ItemStuff[353] := 'Lever';
  SStuff.ItemStuff[354] := 'Switch';
  SStuff.ItemStuff[355] := '?';
  SStuff.ItemStuff[356] := 'Bridge';
  SStuff.ItemStuff[357] := 'Grave';
  SStuff.ItemStuff[358] := 'Plaque';
  SStuff.ItemStuff[359] := '?';
  SStuff.ItemStuff[360] := '?';
  SStuff.ItemStuff[361] := '?';
  SStuff.ItemStuff[362] := '?';
  SStuff.ItemStuff[363] := '?';
  SStuff.ItemStuff[364] := '?';
  SStuff.ItemStuff[365] := '?';
  SStuff.ItemStuff[366] := 'Tmap C Wall';
  SStuff.ItemStuff[367] := 'Tmap S Wall';
  SStuff.ItemStuff[368] := 'Button 1-1';
  SStuff.ItemStuff[369] := 'Button 2-1';
  SStuff.ItemStuff[370] := 'Button 3-1';
  SStuff.ItemStuff[371] := 'Switch 1-1';
  SStuff.ItemStuff[372] := 'Switch 2-1';
  SStuff.ItemStuff[373] := 'Switch 3-1';
  SStuff.ItemStuff[374] := 'Pullchain 1-1';
  SStuff.ItemStuff[375] := 'Pullchain 2-1';
  SStuff.ItemStuff[376] := 'Button 1-2';
  SStuff.ItemStuff[377] := 'Button 2-2';
  SStuff.ItemStuff[378] := 'Button 3-2';
  SStuff.ItemStuff[379] := 'Switch 1-2';
  SStuff.ItemStuff[380] := 'Switch 2-2';
  SStuff.ItemStuff[381] := 'Switch 3-2';
  SStuff.ItemStuff[382] := 'Pullchain 1-2';
  SStuff.ItemStuff[383] := 'Pullchain 2-2';
  SStuff.ItemStuff[384] := 'Damage Trap';
  SStuff.ItemStuff[385] := 'Teleport Trap';
  SStuff.ItemStuff[386] := 'Arrow Trap';
  SStuff.ItemStuff[387] := 'DO Trap';
  SStuff.ItemStuff[388] := 'Pit Trap';
  SStuff.ItemStuff[389] := 'Chng Terrain Trap';
  SStuff.ItemStuff[390] := 'Spell Trap';
  SStuff.ItemStuff[391] := 'Create Object Trap';
  SStuff.ItemStuff[392] := 'Door Trap';
  SStuff.ItemStuff[393] := 'Ward Trap';
  SStuff.ItemStuff[394] := 'Tell Trap';
  SStuff.ItemStuff[395] := 'Delete Object Trap';
  SStuff.ItemStuff[396] := 'Inventory Trap';
  SStuff.ItemStuff[397] := 'Set Variable Trap';
  SStuff.ItemStuff[398] := 'Chk Variable Trap';
  SStuff.ItemStuff[399] := 'Combination Trap';
  SStuff.ItemStuff[400] := 'Text String Trap';
  SStuff.ItemStuff[401] := '?';
  SStuff.ItemStuff[402] := '?';
  SStuff.ItemStuff[403] := '?';
  SStuff.ItemStuff[404] := '?';
  SStuff.ItemStuff[405] := '?';
  SStuff.ItemStuff[406] := '?';
  SStuff.ItemStuff[407] := '?';
  SStuff.ItemStuff[408] := '?';
  SStuff.ItemStuff[409] := '?';
  SStuff.ItemStuff[410] := '?';
  SStuff.ItemStuff[411] := '?';
  SStuff.ItemStuff[412] := '?';
  SStuff.ItemStuff[413] := '?';
  SStuff.ItemStuff[414] := '?';
  SStuff.ItemStuff[415] := '?';
  SStuff.ItemStuff[416] := 'Move Trigger';
  SStuff.ItemStuff[417] := 'Pick Up Trigger';
  SStuff.ItemStuff[418] := 'Use Trigger';
  SStuff.ItemStuff[419] := 'Look Trigger';
  SStuff.ItemStuff[420] := 'Step On Trigger';
  SStuff.ItemStuff[421] := 'Open Trigger';
  SStuff.ItemStuff[422] := 'Unlock Trigger';
  SStuff.ItemStuff[423] := '?';
  SStuff.ItemStuff[424] := '?';
  SStuff.ItemStuff[425] := '?';
  SStuff.ItemStuff[426] := '?';
  SStuff.ItemStuff[427] := '?';
  SStuff.ItemStuff[428] := '?';
  SStuff.ItemStuff[429] := '?';
  SStuff.ItemStuff[430] := '?';
  SStuff.ItemStuff[431] := '?';
  SStuff.ItemStuff[432] := '?';
  SStuff.ItemStuff[433] := '?';
  SStuff.ItemStuff[434] := '?';
  SStuff.ItemStuff[435] := '?';
  SStuff.ItemStuff[436] := '?';
  SStuff.ItemStuff[437] := '?';
  SStuff.ItemStuff[438] := '?';
  SStuff.ItemStuff[439] := '?';
  SStuff.ItemStuff[440] := '?';
  SStuff.ItemStuff[441] := '?';
  SStuff.ItemStuff[442] := '?';
  SStuff.ItemStuff[443] := '?';
  SStuff.ItemStuff[444] := '?';
  SStuff.ItemStuff[445] := '?';
  SStuff.ItemStuff[446] := '?';
  SStuff.ItemStuff[447] := '?';
  SStuff.ItemStuff[448] := 'Some Blood';
  SStuff.ItemStuff[449] := 'Mist Cloud';
  SStuff.ItemStuff[450] := 'Explosion 1';
  SStuff.ItemStuff[451] := 'Explosion 2';
  SStuff.ItemStuff[452] := 'Splash 1';
  SStuff.ItemStuff[453] := 'Splash 2';
  SStuff.ItemStuff[454] := 'Splash 3';
  SStuff.ItemStuff[455] := 'Spell Effect';
  SStuff.ItemStuff[456] := 'Smoke';
  SStuff.ItemStuff[457] := 'Fountain';
  SStuff.ItemStuff[458] := 'Silver Tree';
  SStuff.ItemStuff[459] := 'Damage';
  SStuff.ItemStuff[460] := 'Electricity';
  SStuff.ItemStuff[461] := 'Sound Source';
  SStuff.ItemStuff[462] := 'Changing Terrain';
  SStuff.ItemStuff[463] := 'Moving Door';
  SStuff.ItemStuff[464] := '?';
  SStuff.ItemStuff[465] := '?';
  SStuff.ItemStuff[466] := '?';
  SStuff.ItemStuff[467] := '?';
  SStuff.ItemStuff[468] := '?';
  SStuff.ItemStuff[469] := '?';
  SStuff.ItemStuff[470] := '?';
  SStuff.ItemStuff[471] := '?';
  SStuff.ItemStuff[472] := '?';
  SStuff.ItemStuff[473] := '?';
  SStuff.ItemStuff[474] := '?';
  SStuff.ItemStuff[475] := '?';
  SStuff.ItemStuff[476] := '?';
  SStuff.ItemStuff[477] := '?';
  SStuff.ItemStuff[478] := '?';
  SStuff.ItemStuff[479] := '?';
  SStuff.ItemStuff[480] := '?';
  SStuff.ItemStuff[481] := '?';
  SStuff.ItemStuff[482] := '?';
  SStuff.ItemStuff[483] := '?';
  SStuff.ItemStuff[484] := '?';
  SStuff.ItemStuff[485] := '?';
  SStuff.ItemStuff[486] := '?';
  SStuff.ItemStuff[487] := '?';
  SStuff.ItemStuff[488] := '?';
  SStuff.ItemStuff[489] := '?';
  SStuff.ItemStuff[490] := '?';
  SStuff.ItemStuff[491] := '?';
  SStuff.ItemStuff[492] := '?';
  SStuff.ItemStuff[493] := '?';
  SStuff.ItemStuff[494] := '?';
  SStuff.ItemStuff[495] := '?';
  SStuff.ItemStuff[496] := '?';
  SStuff.ItemStuff[497] := '?';
  SStuff.ItemStuff[498] := '?';
  SStuff.ItemStuff[499] := '?';
  SStuff.ItemStuff[500] := '?';
  SStuff.ItemStuff[501] := '?';
  SStuff.ItemStuff[502] := '?';
  SStuff.ItemStuff[503] := '?';
  SStuff.ItemStuff[504] := '?';
  SStuff.ItemStuff[505] := '?';
  SStuff.ItemStuff[506] := '?';
  SStuff.ItemStuff[507] := '?';
  SStuff.ItemStuff[508] := '?';
  SStuff.ItemStuff[509] := '?';
  SStuff.ItemStuff[510] := '?';
  SStuff.ItemStuff[511] := '?';
  SStuff.Spells[00] := 'Light';
  SStuff.Spells[01] := 'Resist Blows';
  SStuff.Spells[02] := 'Magic Arrow';
  SStuff.Spells[03] := 'Create Food';
  SStuff.Spells[04] := 'Stealth';
  SStuff.Spells[05] := 'Leap';
  SStuff.Spells[06] := 'Curse';
  SStuff.Spells[07] := 'Slow Fall';
  SStuff.Spells[08] := 'Lesser Heal';
  SStuff.Spells[09] := 'Detect Monster';
  SStuff.Spells[10] := 'Cause Fear';
  SStuff.Spells[11] := 'Rune of Warding';
  SStuff.Spells[12] := 'Speed';
  SStuff.Spells[13] := 'Conceal';
  SStuff.Spells[14] := 'Night Vision';
  SStuff.Spells[15] := 'Electrical Bolt';
  SStuff.Spells[16] := 'Strengthen Door';
  SStuff.Spells[17] := 'Thick Skin';
  SStuff.Spells[18] := 'Water Walk';
  SStuff.Spells[19] := 'Heal';
  SStuff.Spells[20] := 'Levitate';
  SStuff.Spells[21] := 'Poison';
  SStuff.Spells[22] := 'Flameproof';
  SStuff.Spells[23] := 'Remove Trap';
  SStuff.Spells[24] := 'Fireball';
  SStuff.Spells[25] := 'Smite Undead';
  SStuff.Spells[26] := 'Name Enchantment';
  SStuff.Spells[27] := 'Missile Protection';
  SStuff.Spells[28] := 'Open';
  SStuff.Spells[29] := 'Cure Poison';
  SStuff.Spells[30] := 'Greater Heal';
  SStuff.Spells[31] := 'Sheet Lightning';
  SStuff.Spells[32] := 'Gate Travel';
  SStuff.Spells[33] := 'Paralyze';
  SStuff.Spells[34] := 'Daylight';
  SStuff.Spells[35] := 'Telekinesis';
  SStuff.Spells[36] := 'Fly';
  SStuff.Spells[37] := 'Ally';
  SStuff.Spells[38] := 'Summon Monster';
  SStuff.Spells[39] := 'Invisibility';
  SStuff.Spells[40] := 'Confusion';
  SStuff.Spells[41] := 'Reveal';
  SStuff.Spells[42] := 'Iron Flesh';
  SStuff.Spells[43] := 'Tremor';
  SStuff.Spells[44] := 'Roaming Sight';
  SStuff.Spells[45] := 'Flame Wind';
  SStuff.Spells[46] := 'Freeze Time';
  SStuff.Spells[47] := 'Armageddon';
  SStuff.Spells[48] := 'Mass Paralyze';
  SStuff.Spells[49] := 'Acid';
  SStuff.Spells[50] := 'Local Teleport';
  SStuff.Spells[51] := 'Mana Boost';
  SStuff.Spells[52] := 'Restore Mana';
  SStuff.Spells[53] := '?';
  SStuff.Spells[54] := '?';
  SStuff.Spells[55] := '?';
  SStuff.Spells[56] := '?';
  SStuff.Spells[57] := '?';
  SStuff.Spells[58] := '?';
  SStuff.Spells[59] := '?';
  SStuff.Spells[60] := '?';
  SStuff.Spells[61] := '?';
  SStuff.Spells[62] := '?';
  SStuff.Spells[63] := '?';
End; {Setup}

Procedure ReadPlayer (Var PlayerDat: PlayerFile {In/Out};
                      Var Character: CharArray{Out};
                      Var Inventory: InventRecord{Out});
Var
  Loop: Integer;
  XORValue: Byte;
  IncrNum: Byte;
Begin
  Assign (PlayerDat, 'player.dat');
  Reset (PlayerDat);
  For Loop:= 0 to 311 do
    Read (PlayerDat,Character[Loop]);
  XORValue := Character[0];
  IncrNum:=3;
{  For Loop:= 1 to 220 do begin}
  For Loop:= 1 to 220 do begin
    If Loop=81 then IncrNum := 3;
    Character[Loop] := (Character[Loop]) xor (XORValue + IncrNum);
    IncrNum := IncrNum + 3;
  End;
  Inventory.NumItems := 0;
  While not(eof(PlayerDat)) do begin
    Inventory.NumItems := Inventory.NumItems + 1;
    For Loop:=0 to 7 do
      Read (PlayerDat,Inventory.Items[Inventory.NumItems][Loop]);
  End; {While}
  Close (PlayerDat);
End; {ReadPlayer}

Procedure WritePlayer (Var PlayerDat: PlayerFile {In/Out};
                       Character: CharArray{Out};
                       Inventory: InventRecord{Out});
Var
  Loop,Loop2: Integer;
  XORValue: Byte;
  IncrNum: Byte;
Begin
  Assign (PlayerDat, 'player.dat');
  Rewrite (PlayerDat);
  XORValue := Character[0];
  IncrNum:=3;
{  For Loop:= 1 to 220 do begin}
  For Loop:= 1 to 220 do begin
    If Loop=81 then IncrNum := 3;
    Character[Loop] := (Character[Loop]) xor (XORValue + IncrNum);
    IncrNum := IncrNum + 3;
  End;
  For Loop:= 0 to 311 do
    Write (PlayerDat,Character[Loop]);
  Loop := 0;
  While Loop<Inventory.NumItems do begin
    Loop := Loop + 1;
    For Loop2:=0 to 7 do
      Write (PlayerDat,Inventory.Items[Loop][Loop2]);
  End; {While}
  Close (PlayerDat);
End; {WritePlayer}

Procedure DisplayStats (Var SStuff: Stuff{In}; Character: CharArray{In});
Var
  Loop: Byte;
  Temp1,Temp2: Word;
  ITemp: Integer;
  Disp: Real;
Begin
  ClrScr;
  For Loop := 0 to 22 do begin
    GotoXY(1,Loop+1);
    Write ('[',(Loop+1):2,'] ',SStuff.Abilities[Loop],' ',
           Character[Loop+31]);
  End;
  GotoXY(30,1);
  Write ('[A] ',SStuff.Name,' ');
  Loop := 1;
  While Character[Loop]<>0 do begin
    Write (Chr(Character[Loop]));
    Loop := Loop + 1;
  End;
  GotoXY(30,3);
  Write ('[B] ',SStuff.VitCur,' ',Character[221]);
  GotoXY(30,4);
  Write ('[C] ',SStuff.VitMax,' ',Character[55]);
  GotoXY(30,5);
  Write ('[D] ',SStuff.CurMana,' ',Character[56]);
  GotoXY(30,6);
  Write ('[E] ',SStuff.MaxMana,' ',Character[57]);
  GotoXY(30,7);
  Write ('[F] ',SStuff.Food,' ',Character[58]);
  GotoXY(30,8);
  Write ('[G] ',SStuff.Level,' ',Character[62]);
  GotoXY(30,9);
  ITemp := Character[77] + (Character[78] * 256);
  Disp := ITemp / 10;
  Write ('[H] ',SStuff.Encum,' ',Disp:0:1);
  Temp1 := Character[79] + (Character[80] * 256);
  Temp2 := Character[81] + (Character[82] * 256);
  Disp := Temp2;
  Disp := Disp * 65536;
  Disp := (Disp + Temp1) / 10;
  GotoXY (30,10);
  Write ('[J] ',SStuff.XP,' ',Disp:0:1);
  GotoXY(30,12);
  Temp1 := Character[91] + (Character[92] * 256);
  Write ('[K] ',SStuff.Head,' ',Temp1);
  GotoXY(30,13);
  Temp1 := Character[93] + (Character[94] * 256);
  Write ('[L] ',SStuff.DLevel,' ',Temp1);
  GotoXY(30,14);
  Temp1 := Character[85] + (Character[86] * 256);
  Write ('[M] ',SStuff.EWPos,' ',Temp1);
  GotoXY(30,15);
  Temp1 := Character[87] + (Character[88] * 256);
  Write ('[N] ',SStuff.NSPos,' ',Temp1);
  GotoXY(30,16);
  Temp1 := Character[89] + (Character[90] * 256);
  Write ('[O] ',SStuff.UDPos,' ',Temp1);
  GotoXY(30,18);
  Write('[S]ave Character   [R]estore Character');
  GotoXY(30,19);
  Write('[I]nventory        [T]oggle Runes');
  GotoXY(30,20);
  Write('[Q]uit Editing');

  GotoXY (65,2);
  Write ('+-Runebag-+');
  GotoXY (65,3);
  Write ('|         |');
  GotoXY (65,4);
  Write ('|         |');
  GotoXY (65,5);
  Write ('|         |');
  GotoXY (65,6);
  Write ('|         |');
  GotoXY (65,7);
  Write ('|         |');
  GotoXY (65,8);
  Write ('|         |');
  GotoXY (65,9);
  Write ('+---------+');
  GotoXY (67,3);
  If (Character[69] and 128) = 128 then Write('A') Else Write ('.');
  GotoXY (69,3);
  If (Character[69] and 64) = 64 then Write('B') Else Write ('.');
  GotoXY (71,3);
  If (Character[69] and 32) = 32 then Write('C') Else Write ('.');
  GotoXY (73,3);
  If (Character[69] and 16) = 16 then Write('D') Else Write ('.');
  GotoXY (67,4);
  If (Character[69] and 8) = 8 then Write('E') Else Write ('.');
  GotoXY (69,4);
  If (Character[69] and 4) = 4 then Write('F') Else Write ('.');
  GotoXY (71,4);
  If (Character[69] and 2) = 2 then Write('G') Else Write ('.');
  GotoXY (73,4);
  If (Character[69] and 1) = 1 then Write('H') Else Write ('.');
  GotoXY (67,5);
  If (Character[70] and 128) = 128 then Write('I') Else Write ('.');
  GotoXY (69,5);
  If (Character[70] and 64) = 64 then Write('J') Else Write ('.');
  GotoXY (71,5);
  If (Character[70] and 32) = 32 then Write('K') Else Write ('.');
  GotoXY (73,5);
  If (Character[70] and 16) = 16 then Write('L') Else Write ('.');
  GotoXY (67,6);
  If (Character[70] and 8) = 8 then Write('M') Else Write ('.');
  GotoXY (69,6);
  If (Character[70] and 4) = 4 then Write('N') Else Write ('.');
  GotoXY (71,6);
  If (Character[70] and 2) = 2 then Write('O') Else Write ('.');
  GotoXY (73,6);
  If (Character[70] and 1) = 1 then Write('P') Else Write ('.');
  GotoXY (67,7);
  If (Character[71] and 128) = 128 then Write('Q') Else Write ('.');
  GotoXY (69,7);
  If (Character[71] and 64) = 64 then Write('R') Else Write ('.');
  GotoXY (71,7);
  If (Character[71] and 32) = 32 then Write('S') Else Write ('.');
  GotoXY (73,7);
  If (Character[71] and 16) = 16 then Write('T') Else Write ('.');
  GotoXY (67,8);
  If (Character[71] and 8) = 8 then Write('U') Else Write ('.');
  GotoXY (69,8);
  If (Character[71] and 4) = 4 then Write('V') Else Write ('.');
  GotoXY (71,8);
  If (Character[71] and 2) = 2 then Write('W') Else Write ('.');
  GotoXY (73,8);
  If (Character[71] and 1) = 1 then Write('Y') Else Write ('.');
{  GotoXY(30,);
  Write ('[] ',SStuff.,' ',Character[]);}
End;

Procedure GetByte (Description: String{In};
                   Var TheByte: Byte{In/Out});
Begin
  GotoXY(30,22);
  Write ('                                 ');
  GotoXY(30,23);
  Write ('                                 ');
  GotoXY(30,22);
  Write ('Old ',Description,' ',TheByte);
  GotoXY(30,23);
  Write (Description,' ');
  Readln (TheByte);
  GotoXY(30,22);
  Write ('                                 ');
  GotoXY(30,23);
  Write ('                                 ');
End; {GetByte}

Procedure GetWord (Description: String{In};
                   Var OneByte, TwoByte: Byte{In/Out});
Var
  Num: Word;
Begin
  GotoXY(30,22);
  Write ('                                 ');
  GotoXY(30,23);
  Write ('                                 ');
  GotoXY(30,22);
  Num := OneByte + (TwoByte * 256);
  Write ('Old ',Description,' ',Num);
  GotoXY(30,23);
  Write (Description,' ');
  Readln (Num);
  OneByte := Num mod 256;
  TwoByte := Num div 256;
  GotoXY(30,22);
  Write ('                                 ');
  GotoXY(30,23);
  Write ('                                 ');
End; {GetByte}

Procedure Encumber (Var OneByte, TwoByte: Byte{In/Out});
Var
  Itemp: Integer;
  Num: Word;
  Disp: Real;
Begin
  GotoXY(30,22);
  Write ('                                 ');
  GotoXY(30,23);
  Write ('                                 ');
  GotoXY(30,22);
  ITemp := OneByte + (TwoByte * 256);
  Disp := ITemp / 10;
  Write ('Old Encumberance... ',Disp:0:1);
  GotoXY(30,23);
  Write ('Encumberance... ');
  Readln (Disp);
  Disp := Disp * 10;
  If Disp > 32767 then Disp := 32767;
  If Disp < -32768 then Disp := -32768;
  Itemp := Trunc (Disp);
  If Itemp>-1 then Num := Itemp
  Else Num := ITemp + 65536;
  OneByte := Num mod 256;
  TwoByte := Num div 256;
  GotoXY(30,22);
  Write ('                                 ');
  GotoXY(30,23);
  Write ('                                 ');
End; {GetByte}

Procedure Exper (Var OneByte, TwoByte, ThreeByte, FourByte: Byte{In/Out});
Var
  Temp1, Temp2: Word;
  Disp, Disp2: Real;
Begin
  GotoXY(30,22);
  Write ('                                 ');
  GotoXY(30,23);
  Write ('                                 ');
  GotoXY(30,22);
  Temp1 := OneByte + (TwoByte * 256);
  Temp2 := ThreeByte + (FourByte * 256);
  Disp := Temp2;
  Disp := Disp * 65536;
  Disp := (Disp + Temp1) / 10;
  Write ('Old Experience... ',Disp:0:1);
  GotoXY(30,23);
  Write ('Experience... ');
  Readln (Disp);
  If Disp>429496729.5 then Disp := 429496729.5;
  If Disp<0 then Disp := 0;
  Disp := Disp * 10;
  Temp2 := Trunc(Disp / 65536);
  Temp1 := Trunc(Disp - (Temp2 * 65536.0));
  OneByte := Temp1 mod 256;
  TwoByte := Temp1 div 256;
  ThreeByte := Temp2 mod 256;
  FourByte := Temp2 div 256;
  GotoXY(30,22);
  Write ('                                 ');
  GotoXY(30,23);
  Write ('                                 ');
End; {GetByte}

Procedure Name (Var Character:CharArray{In/Out});
Var
  Loop: Integer;
  N: String;
Begin
  GotoXY(30,22);
  Write ('                                 ');
  GotoXY(30,23);
  Write ('                                 ');
  N := '';
  Loop := 1;
  While Character[Loop]<>0 do begin
    N := N + Chr(Character[Loop]);
    Loop := Loop + 1;
  End; {While}
  GotoXY(30,22);
  Write ('Old Name... ',N);
  GotoXY(30,23);
  Write ('New Name... ');
  Readln (N);
  If Length(N)>14 then N[0] := Chr(14);
  For Loop := 1 to Length(N) do
    Character[Loop] := Ord(N[Loop]);
  Character[Length(N)+1] := 0;
  GotoXY(30,22);
  Write ('                                 ');
  GotoXY(30,23);
  Write ('                                 ');
End; {GetByte}

Procedure Runes (Var OneByte, TwoByte, ThreeByte: Byte{In/Out});
Var
  Ch: Char;
Begin
  GotoXY(30,22);
  Write ('                                 ');
  GotoXY(30,23);
  Write ('                                 ');
  GotoXY(30,22);
  Write ('(ABCDEFGHIJKLMNOPQRSTUVWY)');
  GotoXY(30,23);
  Write ('Toggle which rune? -> ');
  Readln (Ch);
  Ch := UpCase (Ch);
  If (Ch='A') then
    If (OneByte and 128) = 128 then
      OneByte := OneByte and (255-128)
    Else
      OneByte := OneByte or 128;
  If (Ch='B') then
    If (OneByte and 64) = 64 then
      OneByte := OneByte and (255-64)
    Else
      OneByte := OneByte or 64;
  If (Ch='C') then
    If (OneByte and 32) = 32 then
      OneByte := OneByte and (255-32)
    Else
      OneByte := OneByte or 32;
  If (Ch='D') then
    If (OneByte and 16) = 16 then
      OneByte := OneByte and (255-16)
    Else
      OneByte := OneByte or 16;
  If (Ch='E') then
    If (OneByte and 8) = 8 then
      OneByte := OneByte and (255-8)
    Else
      OneByte := OneByte or 8;
  If (Ch='F') then
    If (OneByte and 4) = 4 then
      OneByte := OneByte and (255-4)
    Else
      OneByte := OneByte or 4;
  If (Ch='G') then
    If (OneByte and 2) = 2 then
      OneByte := OneByte and (255-2)
    Else
      OneByte := OneByte or 2;
  If (Ch='H') then
    If (OneByte and 1) = 1 then
      OneByte := OneByte and (255-1)
    Else
      OneByte := OneByte or 1;
  If (Ch='I') then
    If (TwoByte and 128) = 128 then
      TwoByte := TwoByte and (255-128)
    Else
      TwoByte := TwoByte or 128;
  If (Ch='J') then
    If (TwoByte and 64) = 64 then
      TwoByte := TwoByte and (255-64)
    Else
      TwoByte := TwoByte or 64;
  If (Ch='K') then
    If (TwoByte and 32) = 32 then
      TwoByte := TwoByte and (255-32)
    Else
      TwoByte := TwoByte or 32;
  If (Ch='L') then
    If (TwoByte and 16) = 16 then
      TwoByte := TwoByte and (255-16)
    Else
      TwoByte := TwoByte or 16;
  If (Ch='M') then
    If (TwoByte and 8) = 8 then
      TwoByte := TwoByte and (255-8)
    Else
      TwoByte := TwoByte or 8;
  If (Ch='N') then
    If (TwoByte and 4) = 4 then
      TwoByte := TwoByte and (255-4)
    Else
      TwoByte := TwoByte or 4;
  If (Ch='O') then
    If (TwoByte and 2) = 2 then
      TwoByte := TwoByte and (255-2)
    Else
      TwoByte := TwoByte or 2;
  If (Ch='P') then
    If (TwoByte and 1) = 1 then
      TwoByte := TwoByte and (255-1)
    Else
      TwoByte := TwoByte or 1;
  If (Ch='Q') then
    If (ThreeByte and 128) = 128 then
      ThreeByte := ThreeByte and (255-128)
    Else
      ThreeByte := ThreeByte or 128;
  If (Ch='R') then
    If (ThreeByte and 64) = 64 then
      ThreeByte := ThreeByte and (255-64)
    Else
      ThreeByte := ThreeByte or 64;
  If (Ch='S') then
    If (ThreeByte and 32) = 32 then
      ThreeByte := ThreeByte and (255-32)
    Else
      ThreeByte := ThreeByte or 32;
  If (Ch='T') then
    If (ThreeByte and 16) = 16 then
      ThreeByte := ThreeByte and (255-16)
    Else
      ThreeByte := ThreeByte or 16;
  If (Ch='U') then
    If (ThreeByte and 8) = 8 then
      ThreeByte := ThreeByte and (255-8)
    Else
      ThreeByte := ThreeByte or 8;
  If (Ch='V') then
    If (ThreeByte and 4) = 4 then
      ThreeByte := ThreeByte and (255-4)
    Else
      ThreeByte := ThreeByte or 4;
  If (Ch='W') then
    If (ThreeByte and 2) = 2 then
      ThreeByte := ThreeByte and (255-2)
    Else
      ThreeByte := ThreeByte or 2;
  If (Ch='Y') then
    If (ThreeByte and 1) = 1 then
      ThreeByte := ThreeByte and (255-1)
    Else
      ThreeByte := ThreeByte or 1;
  GotoXY(30,22);
  Write ('                                 ');
  GotoXY(30,23);
  Write ('                                 ');
End; {GetByte}

Procedure DisplayInventory (Var SStuff: Stuff{In};
                            Var Inventory: InventRecord{In};
                            ItemNum: Integer{In});
Var
  TheItem, Condition, Number, Belongingness: Integer;
Begin
  ClrScr;
  GotoXY (17,1);
  Write ('Total Number of Items.. ',Inventory.NumItems);
  GotoXY (17,2);
  Write ('Current Item........... ',ItemNum);
  TheItem := Inventory.Items[ItemNum][0] +
               ((Inventory.Items[ItemNum][1] and 1) * 256);
  Condition := Inventory.Items[ItemNum][4] and (1+2+4+8+16+32);
  Number := ((Inventory.Items[ItemNum][6] and (64+128)) div 64) +
            ((Inventory.Items[ItemNum][7] and 127) * 4);
  Belongingness := (Inventory.Items[ItemNum][6] and 63);
  GotoXY (17,4);
  Write ('[D] Name of Current Item... [',TheItem,'] ',SStuff.ItemStuff[TheItem]);
  GotoXY (17,5);
  Write ('[E] Condition.............. ',Condition);
  GotoXY (17,6);
  If (TheItem = 288) then begin
    Write ('[F] Spell Name............. [',Number,'] ',Sstuff.Spells[Number]);
  End Else If ((Inventory.Items[ItemNum][7] and 128) = 128) then begin
    Write ('[F] Of..................... ');
    If (Number in [8..16,22..48,58..63,80..127,144..175,208..211,214..223]) or
       (Number > 255) then Write ('??? [',Number,']');
    If (Number<256) then begin
      If (Number in [0..7]) then begin
        If Number=0 then Write ('Darkness [0]');
        If Number=1 then Write ('Burning Match [1]');
        If Number=2 then Write ('Candle Light [2]');
        If Number=3 then Write ('Light [3]');
        If Number=4 then Write ('Magic Lantern [4]');
        If Number=5 then Write ('Night Vision [5]');
        If Number=6 then Write ('Daylight [6]');
        If Number=7 then Write ('Sunlight [7]');
      End; {If}
      If (Number in [17..21]) then begin
        If Number=17 then Write ('Leap [17]');
        If Number=18 then Write ('Slow Fall [18]');
        If Number=19 then Write ('Levitate [19]');
        If Number=20 then Write ('Water Walk [20]');
        If Number=21 then Write ('Fly [21]');
      End; {If}
      If (Number in [212,213]) then begin
        If Number=212 then Write ('Maze Navigation [212]');
        If Number=213 then Write ('Hallucination [213]');
      End; {If}
      If (Number in [49..57]) then begin
        If Number=49 then Write ('Curse [49]');
        If Number=50 then Write ('Stealth [50]');
        If Number=51 then Write ('Conceal [51]');
        If Number=52 then Write ('Invisibility [52]');
        If Number=53 then Write ('Missile Protection [53]');
        If Number=54 then Write ('Flame Proof [54]');
        If Number=55 then Write ('Poison Resistance [55]');
        If Number=56 then Write ('Magic Protection [56]');
        If Number=57 then Write ('Greater Magic Protection [57]');
      End; {If}
      If (Number in [176..191]) then begin
        If Number=176 then Write ('Speed [176]');
        If Number=177 then Write ('Detect Monster [177]');
        If Number=178 then Write ('Strengthen Door [178]');
        If Number=179 then Write ('Roaming Sight [179]');
        If Number=180 then Write ('Remove Trap [180]');
        If Number=181 then Write ('Open [181]');
        If Number=182 then Write ('Cure Poison [182]');
        If Number=183 then Write ('Name Enchantment [183]');
        If Number=184 then Write ('Telekinesis [184]');
        If Number=185 then Write ('Tremor [185]');
        If Number=186 then Write ('Gate Travel [186]');
        If Number=187 then Write ('Freeze Time [187]');
        If Number=188 then Write ('Armageddon [188]');
        If Number=189 then Write ('Unnamed [189]');
        If Number=190 then Write ('Regeneration [190]');
        If Number=191 then Write ('Mana Regeneration [191]');
      End; {If}
      If (Number in [64..79]) then
        Write ('Level ',Number-64,' Healing [',Number,']');
      If (Number in [200..207]) then
        Write ('Level ',Number-200,' Toughness [',Number,']');
      If (Number in [192..199]) then
        Write ('Level ',Number-192,' Protection [',Number,']');
    End; {If < 256}
  End Else Write ('[F] How many............... ',Number);
  GotoXY (17,7);
  Write ('[G] Belongingness.......... ',Belongingness);
  GotoXY (17,8);
  Write ('[H] Toggle Of Flag');
  GotoXY (17,10);
  Write ('[N]ext Item        [P]revious Item');
  GotoXY (17,11);
  Write ('[S]ave Character   [R]estore Character');
  GotoXY (17,12);
  Write ('[C]hange Menu      [Num]ber of Item');
  GotoXY (17,13);
  Write ('[Q]uit Editing');
End;

Procedure EditStats (Var SStuff: Stuff{In}; Var Character: CharArray{In/Out};
                     Var Inventory: InventRecord{In/Out};
                     Var PlayerDat: PlayerFile{In/Out});
Var
  User: String;
  Ch: Char;
  ItemNum, Num, Dummy: Integer;
  InByte: Byte;
Begin
  ItemNum := 1;
  Ch := ' ';
  While not(Ch ='Q') do begin
    While not(Ch in ['Q','I']) do begin
      DisplayStats (SStuff,Character);
      GotoXY (30,23);
      Write ('Your choice -> ');
      Readln (User);
      Val (User, Num, Dummy);
      If (Dummy<>0) or not(Num in [1..23]) then begin
        Dummy := -1;
        Ch := User[1];
        Ch := UpCase(Ch);
        If length(User)=0 then Ch:=' ';
      End Else Ch:=' ';
      If (Ch='R') then ReadPlayer (PlayerDat,Character,Inventory);
      If (Ch='S') then WritePlayer (PlayerDat,Character,Inventory);
      If Dummy=0 then GetByte (SStuff.Abilities[Num-1],Character[Num+30]);
      If (Ch='B') then GetByte (SStuff.VitCur,Character[221]);
      If (Ch='C') then GetByte (SStuff.VitMax,Character[55]);
      If (Ch='D') then GetByte (SStuff.CurMana,Character[56]);
      If (Ch='E') then GetByte (SStuff.MaxMana,Character[57]);
      If (Ch='F') then GetByte (SStuff.Food,Character[58]);
      If (Ch='G') then GetByte (SStuff.Level,Character[62]);
      If (Ch='T') then Runes (Character[69],Character[70],Character[71]);
      If (Ch='K') then GetWord (SStuff.Head,Character[91],Character[92]);
      If (Ch='L') then GetWord (SStuff.DLevel,Character[93],Character[94]);
      If (Ch='M') then GetWord (SStuff.EWPos,Character[85],Character[86]);
      If (Ch='N') then GetWord (SStuff.NSPos,Character[87],Character[88]);
      If (Ch='O') then GetWord (SStuff.UDPos,Character[89],Character[90]);
      If (Ch='H') then Encumber (Character[77],Character[78]);
      If (Ch='J') then Exper (Character[79], Character[80],
                              Character[81], Character[82]);
      If (Ch='A') then Name (Character);
    End; {While}
    While not(Ch in ['Q','C']) and (Inventory.NumItems>0) do begin
      DisplayInventory (SStuff,Inventory,ItemNum);
      GotoXY (21,18);
      Write ('Your choice -> ');
      Readln (User);
      Val (User, Num, Dummy);
      If (Dummy<>0) or ((Num>Inventory.NumItems) or (Num<1)) then begin
        Dummy := -1;
        Ch := User[1];
        Ch := UpCase(Ch);
        If length(User)=0 then Ch:=' ';
      End Else Ch:=' ';
      If Dummy=0 then ItemNum := Num;
      If (Ch='R') then ReadPlayer (PlayerDat,Character,Inventory);
      If (Ch='S') then WritePlayer (PlayerDat,Character,Inventory);
      If (Ch='N') then begin
        ItemNum := ItemNum + 1;
        If ItemNum > Inventory.NumItems then ItemNum := 1;
      End;
      If (Ch='P') then begin
        ItemNum := ItemNum - 1;
        If ItemNum < 1 then ItemNum := Inventory.NumItems;
      End;
      If (Ch='F') then begin
        Num := ((Inventory.Items[ItemNum][6] and (64+128)) div 64) +
               ((Inventory.Items[ItemNum][7] and 127) * 4);
        GotoXY (21,19);
        Write ('Old value for [F]: ',Num);
        GotoXY (21,20);
        Write ('New value for [F]: ');
        Readln (Num);
        If Num>511 then Num:= 511;
        If Num<0 then Num:= 0;
        Inventory.Items[ItemNum][6] := (Inventory.Items[ItemNum][6] and 63)
                                       or ((Num and 3) * 64);
        Inventory.Items[ItemNum][7] := (Inventory.Items[ItemNum][7] and 128)
                                       or (Num div 4);
      End; {If F}
      If (Ch='D') then begin
        Num := Inventory.Items[ItemNum][0] +
               ((Inventory.Items[ItemNum][1] and 1) * 256);
        GotoXY (21,19);
        Write ('Old value for [D]: ',Num);
        GotoXY (21,20);
        Write ('New value for [D]: ');
        Readln (Num);
        If Num>511 then Num:= 511;
        If Num<0 then Num:= 0;
        Inventory.Items[ItemNum][0] := (Num and 255);
        Inventory.Items[ItemNum][1] := (Inventory.Items[ItemNum][1] and 254)
                                       or (Num div 256);
      End; {If D}
      If (Ch='E') then begin
        Num := Inventory.Items[ItemNum][4] and 63;
        GotoXY (21,19);
        Write ('Old value for [E]: ',Num);
        GotoXY (21,20);
        Write ('New value for [E]: ');
        Readln (Num);
        If Num>63 then Num:= 63;
        If Num<0 then Num:= 0;
        Inventory.Items[ItemNum][4] := (Inventory.Items[ItemNum][4] and 192)
                                       or Num;
      End; {If E}
      If (Ch='G') then begin
        Num := Inventory.Items[ItemNum][6] and 63;
        GotoXY (21,19);
        Write ('Old value for [G]: ',Num);
        GotoXY (21,20);
        Write ('New value for [G]: ');
        Readln (Num);
        If Num>63 then Num:= 63;
        If Num<0 then Num:= 0;
        Inventory.Items[ItemNum][6] := (Inventory.Items[ItemNum][6] and 192)
                                       or Num;
      End; {If G}
      If (Ch='H') then begin
        If ((Inventory.Items[ItemNum][7] and 128) = 128) then begin
          Inventory.Items[ItemNum][7] := Inventory.Items[ItemNum][7] and 127;
          Inventory.Items[ItemNum][1] := Inventory.Items[ItemNum][1] and 239;
        End Else Begin
          Inventory.Items[ItemNum][7] := Inventory.Items[ItemNum][7] or 128;
          Inventory.Items[ItemNum][1] := Inventory.Items[ItemNum][1] or 16;
        End;
      End; {If H}

    End; {While}
  End; {While}
End;

Begin
  Setup (SStuff);
  ReadPlayer (PlayerDat,Character,Inventory);
  EditStats (SStuff,Character,Inventory,PlayerDat);
End.